// enjoy trying to understand this

#define WIN32_LEAN_AND_MEAN
#include <Windows.h>

extern "C" __declspec(dllexport) void stub(void) { }
extern "C" int _fltused = 0x9875;

typedef struct {
	float x, y, z;
} Vector3f;

typedef enum {
	BUTTON_L3 = 14,
	BUTTON_R3 = 15
} XboxControllerButtons;

HMODULE g_dxhr = NULL;
bool g_buttonPressedLastFrame = false;
bool g_isDirectorsCut = false;

void* GetCameraManager()
{
	__asm {
		mov eax, [g_dxhr]
		cmp g_isDirectorsCut, 1
		jge dc
		mov eax, [eax+0x1858800]
		jmp done
	dc:
		mov eax, [eax+0x187CEC0]
	done:
		nop
	}
}

void* GetCurrentCamera()
{
	__asm {
		call GetCameraManager
		cmp eax, 0
		je done
		mov eax, [eax+0x30]
	done:
		nop
	}
}

Vector3f* GetCurrentCameraPos()
{
	__asm {
		call GetCurrentCamera
		add eax, 0x80
	}
}

void __stdcall SetCurrentCamera(void* camera)
{
	__asm {
		call GetCameraManager
		mov ebx, camera
		mov [eax+0x30], ebx
	}
}

void* GetFreeCam()
{
	__asm {
		call GetCameraManager
		add eax, 0x550
	}
}

void* GetPlayerCam()
{
	__asm {
		call GetCameraManager
		add eax, 0x6F0
	}
}

bool IsFreeCam()
{
	void* cam = GetCurrentCamera();
	return cam != NULL && cam == GetFreeCam();
}

void __stdcall Camera__TransferTo(void* this_, void* other)
{
	__asm {
		mov eax, this_  // vtable
		mov eax, [eax]

		add eax, 0x30 // TransferTo func
		mov eax, [eax]

		push other
		mov ecx, this_
		call eax
	}
}

void __stdcall Camera__TransferFrom(void* this_, void* other)
{
	__asm {
		mov eax, this_ // vtable
		mov eax, [eax]

		add eax, 0x2c // TransferFrom func
		mov eax, [eax]

		push other
		mov ecx, this_
		call eax
	}
}

void SetFreeCam()
{
	__asm {
		call GetCurrentCamera
		mov ebx, eax // ebx = old cam

		call GetFreeCam
		push eax // arg0 = freecam (new cam)
		push ebx
		call Camera__TransferTo

		call GetFreeCam
		push eax
		call SetCurrentCamera

		call GetFreeCam
		push ebx // arg0 = old cam
		push eax
		call Camera__TransferFrom
	}
}

void SetPlayerCam()
{
	__asm {
		call GetCurrentCamera
		mov ebx, eax // ebx = old cam

		call GetPlayerCam
		push eax // arg0 = freecam (new cam)
		push ebx
		call Camera__TransferTo

		call GetPlayerCam
		push eax
		call SetCurrentCamera

		call GetPlayerCam
		push ebx // arg0 = old cam
		push eax
		call Camera__TransferFrom
	}
}

void* SetPlayerPos(Vector3f pos)
{
	__asm {
		// current pos
		mov eax, [g_dxhr]
		cmp g_isDirectorsCut, 1
		jge dc
		mov eax, [eax+0x9E8450]
		add eax, 0x20
		jmp go

	dc:
		mov eax, [eax+0x1602738]
		mov eax, [eax+0x14]
		mov eax, [eax+0x40]
		add eax, 0x20
	
	go:
		mov ebx, pos.x
		mov [eax], ebx

		add eax, 4
		mov ebx, pos.y
		mov [eax], ebx

		add eax, 4
		mov ebx, pos.z
		mov [eax], ebx

		// previous pos (to prevent collision)
		mov eax, [g_dxhr]
		cmp g_isDirectorsCut, 1
		jge dc2
		mov eax, [eax+0xA07088]
		mov eax, [eax+0x480]
		mov eax, [eax+0x160]
		add eax, 0x80
		jmp go2

	dc2:
		mov eax, [eax+0x187BF64]
		add eax, 0x23D0

	go2:
		mov ebx, pos.x
		mov [eax], ebx

		add eax, 4
		mov ebx, pos.y
		mov [eax], ebx

		add eax, 4
		mov ebx, pos.z
		mov [eax], ebx
	}
}

void* __stdcall GetXboxController(int controller)
{
	__asm {
		mov eax, [g_dxhr]
		cmp g_isDirectorsCut, 1
		jge dc
		add eax, 0xAC0F0
		jmp go
	dc:
		add eax, 0xAC390
	go:
		push controller
		call eax
	}
}

bool IsXboxButtonPressed(int button)
{
	__asm {
		push 0 // first controller
		call GetXboxController
		mov ecx, eax
		xor eax, eax
		cmp ecx, 0 // check if it returned null
		je done

		mov eax, [g_dxhr]
		cmp g_isDirectorsCut, 1
		jge dc
		add eax, 0xAD1F0
		jmp go
	dc:
		add eax, 0xAD440
	go:
		push button // receive bacon
		call eax

	done:
		nop
	}
}

bool PlayerHasControl()
{
	__asm {
		mov eax, [g_dxhr]
		cmp g_isDirectorsCut, 1
		jge dc
		mov eax, [eax+0x15A9264]
		cmp eax, 0
		je done
		mov eax, [eax+0x13c]
		mov eax, [eax+0x30]
		jmp done
	dc:
		mov eax, [eax+0xA5099C]
		cmp eax, 0
		je done
		mov eax, [eax+0x300]
		mov eax, [eax+4]
		mov eax, [eax+0x30]
	done:
		nop
	}
}

void AppendBuildNumber(char* msg)
{
	lstrcat((char*)g_dxhr + (g_isDirectorsCut ? 0xA50708 : 0xA34288), msg);
}

DWORD WINAPI MainThread(LPVOID lpParam)
{
	Sleep(1000);

	AppendBuildNumber(" noclipmod");

	Sleep(4000); // let the game load a bit

	while (true)
	{
		Sleep(16);

		// don't check button presses during load screens
		if (!PlayerHasControl() && !IsFreeCam())
			continue;

		bool pressed = (IsXboxButtonPressed(BUTTON_L3) && IsXboxButtonPressed(BUTTON_R3))
			|| GetAsyncKeyState(VK_F3);

		if (pressed && !g_buttonPressedLastFrame)
		{
			if (IsFreeCam())
			{
				SetPlayerPos(*GetCurrentCameraPos());
				SetPlayerCam();
			}
			else
			{
				SetFreeCam();
			}
		}

		g_buttonPressedLastFrame = pressed;
	}

	return 0;
}

extern "C" bool WINAPI _DllMainCRTStartup(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpReserved)
{
	if (fdwReason == DLL_PROCESS_ATTACH)
	{
		OutputDebugString("dxhr_noclip: attached");

		g_dxhr = GetModuleHandle(NULL);

		char dllName[128];
		GetModuleFileName(g_dxhr, dllName, sizeof(dllName));
		int len = lstrlen(dllName);
		if (dllName[len-6] == 'D' && dllName[len-5] == 'C')
			g_isDirectorsCut = true;

		CreateThread(NULL, 0, MainThread, NULL, 0, NULL);
	}

    return true;
}
